// This file was auto-generated by SRProxy's gen_srproxy.
// DO NOT EDIT IT DIRECTLY.

#pragma once


#include "SRProxy/FlatBasicTypes.h"

#include "duneanaobj/StandardRecord/Flat//FwdDeclare.h"


/// Flat encoding of \ref caf::SRVector3D
template<> class flat::Flat<caf::SRVector3D>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRVector3D& sr);
  void Clear();

protected:

  flat::Flat<float> x;
  flat::Flat<float> y;
  flat::Flat<float> z;
};

/// Flat encoding of \ref caf::SRGAr
template<> class flat::Flat<caf::SRGAr>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRGAr& sr);
  void Clear();

protected:

  flat::Flat<int> gastpc_pi_min_mult;
  flat::Flat<int> gastpc_pi_pl_mult;
  flat::Flat<int> nFSP;
  flat::Flat<std::vector<float>> partEvReco;
  flat::Flat<std::vector<int>> pdg;
  flat::Flat<std::vector<float>> ptrue;
  flat::Flat<std::vector<float>> trkLen;
  flat::Flat<std::vector<float>> trkLenPerp;
};

/// Flat encoding of \ref caf::SRLorentzVector
template<> class flat::Flat<caf::SRLorentzVector>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRLorentzVector& sr);
  void Clear();

protected:

  flat::Flat<float> E;
  flat::Flat<float> px;
  flat::Flat<float> py;
  flat::Flat<float> pz;
};

/// Flat encoding of \ref caf::SRParticleTruth
template<> class flat::Flat<caf::SRParticleTruth>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRParticleTruth& sr);
  void Clear();

protected:

  flat::Flat<caf::SRLorentzVector> motherp;
  flat::Flat<int> motherpdg;
  flat::Flat<caf::SRLorentzVector> p;
  flat::Flat<int> pdg;
  flat::Flat<caf::SRVector3D> start;
  flat::Flat<int> trkid;
};

/// Flat encoding of \ref caf::SRShower
template<> class flat::Flat<caf::SRShower>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRShower& sr);
  void Clear();

protected:

  flat::Flat<float> Evis;
  flat::Flat<caf::SRVector3D> direction;
  flat::Flat<caf::SRVector3D> start;
  flat::Flat<caf::SRParticleTruth> truth;
};

/// Flat encoding of \ref caf::SRTrack
template<> class flat::Flat<caf::SRTrack>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRTrack& sr);
  void Clear();

protected:

  flat::Flat<float> E;
  flat::Flat<float> Evis;
  flat::Flat<caf::SRVector3D> dir;
  flat::Flat<caf::SRVector3D> end;
  flat::Flat<caf::SRVector3D> enddir;
  flat::Flat<float> len_cm;
  flat::Flat<float> len_gcm2;
  flat::Flat<float> qual;
  flat::Flat<caf::SRVector3D> start;
  flat::Flat<caf::SRParticleTruth> truth;
};

/// Flat encoding of \ref caf::SRNDLAr
template<> class flat::Flat<caf::SRNDLAr>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRNDLAr& sr);
  void Clear();

protected:

  flat::Flat<std::size_t> nshowers;
  flat::Flat<std::size_t> ntracks;
  flat::Flat<std::vector<caf::SRShower>> showers;
  flat::Flat<std::vector<caf::SRTrack>> tracks;
};

/// Flat encoding of \ref caf::SRTMS
template<> class flat::Flat<caf::SRTMS>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRTMS& sr);
  void Clear();

protected:

  flat::Flat<std::size_t> ntracks;
  flat::Flat<std::vector<caf::SRTrack>> tracks;
};

/// Flat encoding of \ref caf::SRNDTrackAssn
template<> class flat::Flat<caf::SRNDTrackAssn>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRNDTrackAssn& sr);
  void Clear();

protected:

  flat::Flat<float> angdispl;
  flat::Flat<int> larid;
  flat::Flat<int> tmsid;
  flat::Flat<float> transdispl;
};

/// Flat encoding of \ref caf::SRNDBranch
template<> class flat::Flat<caf::SRNDBranch>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::SRNDBranch& sr);
  void Clear();

protected:

  flat::Flat<std::size_t> LArID;
  flat::Flat<float> Residual;
  flat::Flat<std::size_t> TMSID;
  flat::Flat<float> cosTheta;
  flat::Flat<caf::SRGAr> gar;
  flat::Flat<caf::SRNDLAr> lar;
  flat::Flat<std::size_t> ntrkmatch;
  flat::Flat<caf::SRTMS> tms;
  flat::Flat<std::vector<caf::SRNDTrackAssn>> trkmatch;
};

/// Flat encoding of \ref caf::StandardRecord
template<> class flat::Flat<caf::StandardRecord>
{
public:
  Flat(TTree* tr, const std::string& prefix, const std::string& totsize, const IBranchPolicy* policy);

  void Fill(const caf::StandardRecord& sr);
  void Clear();

protected:

  flat::Flat<float> CVNResult0Neutrons;
  flat::Flat<float> CVNResult0Pions;
  flat::Flat<float> CVNResult0Pizeros;
  flat::Flat<float> CVNResult0Protons;
  flat::Flat<float> CVNResult1Neutrons;
  flat::Flat<float> CVNResult1Pions;
  flat::Flat<float> CVNResult1Pizeros;
  flat::Flat<float> CVNResult1Protons;
  flat::Flat<float> CVNResult2Neutrons;
  flat::Flat<float> CVNResult2Pions;
  flat::Flat<float> CVNResult2Pizeros;
  flat::Flat<float> CVNResult2Protons;
  flat::Flat<float> CVNResultIsAntineutrino;
  flat::Flat<float> CVNResultNC;
  flat::Flat<float> CVNResultNNeutrons;
  flat::Flat<float> CVNResultNPions;
  flat::Flat<float> CVNResultNPizeros;
  flat::Flat<float> CVNResultNProtons;
  flat::Flat<float> CVNResultNue;
  flat::Flat<float> CVNResultNumu;
  flat::Flat<float> CVNResultNutau;
  flat::Flat<float> Ehad_veto;
  flat::Flat<float> Elep;
  flat::Flat<float> Elep_reco;
  flat::Flat<float> Ev;
  flat::Flat<float> Ev_reco;
  flat::Flat<float> Ev_reco_nue;
  flat::Flat<float> Ev_reco_numu;
  flat::Flat<int> GENIE_ScatteringMode;
  flat::Flat<float> LepE;
  flat::Flat<caf::SRVector3D> LepEndpoint;
  flat::Flat<float> LepMomX;
  flat::Flat<float> LepMomY;
  flat::Flat<float> LepMomZ;
  flat::Flat<float> LepNuAngle;
  flat::Flat<int> LepPDG;
  flat::Flat<int> LongestTrackContNumu;
  flat::Flat<float> NuMomX;
  flat::Flat<float> NuMomY;
  flat::Flat<float> NuMomZ;
  flat::Flat<float> Q2;
  flat::Flat<float> RecoHadEnNue;
  flat::Flat<float> RecoHadEnNumu;
  flat::Flat<float> RecoLepEnNue;
  flat::Flat<float> RecoLepEnNumu;
  flat::Flat<int> RecoMethodNue;
  flat::Flat<int> RecoMethodNumu;
  flat::Flat<float> RegCNNNueE;
  flat::Flat<int> TrackMomMethodNumu;
  flat::Flat<float> W;
  flat::Flat<float> X;
  flat::Flat<float> Y;
  flat::Flat<float> cvnnc;
  flat::Flat<float> cvnnue;
  flat::Flat<float> cvnnumu;
  flat::Flat<float> cvnnutau;
  flat::Flat<std::vector<float>> cvwgt;
  flat::Flat<float> det_x;
  flat::Flat<float> eDepN;
  flat::Flat<float> eDepOther;
  flat::Flat<float> eDepP;
  flat::Flat<float> eDepPi0;
  flat::Flat<float> eDepPim;
  flat::Flat<float> eDepPip;
  flat::Flat<float> eN;
  flat::Flat<float> eOther;
  flat::Flat<float> eP;
  flat::Flat<float> ePi0;
  flat::Flat<float> ePim;
  flat::Flat<float> ePip;
  flat::Flat<float> eRec_FromDep;
  flat::Flat<float> eRecoN;
  flat::Flat<float> eRecoOther;
  flat::Flat<float> eRecoP;
  flat::Flat<float> eRecoPi0;
  flat::Flat<float> eRecoPim;
  flat::Flat<float> eRecoPip;
  flat::Flat<int> event;
  flat::Flat<int> isCC;
  flat::Flat<int> isFD;
  flat::Flat<int> isFHC;
  flat::Flat<int> meta_run;
  flat::Flat<int> meta_subrun;
  flat::Flat<int> mode;
  flat::Flat<int> muon_contained;
  flat::Flat<int> muon_ecal;
  flat::Flat<int> muon_exit;
  flat::Flat<int> muon_tracker;
  flat::Flat<float> mvanue;
  flat::Flat<float> mvanumu;
  flat::Flat<float> mvaresult;
  flat::Flat<int> nN;
  flat::Flat<int> nNucleus;
  flat::Flat<int> nP;
  flat::Flat<int> nUNKNOWN;
  flat::Flat<caf::SRNDBranch> nd;
  flat::Flat<int> niem;
  flat::Flat<int> nik0;
  flat::Flat<int> nikm;
  flat::Flat<int> nikp;
  flat::Flat<int> niother;
  flat::Flat<int> nipi0;
  flat::Flat<int> nipim;
  flat::Flat<int> nipip;
  flat::Flat<int> nuPDG;
  flat::Flat<int> nuPDGunosc;
  flat::Flat<float> nue_pid;
  flat::Flat<float> numu_pid;
  flat::Flat<int> nwgt_CrazyFlux;
  flat::Flat<double> pileup_energy;
  flat::Flat<double> pot;
  flat::Flat<int> reco_lepton_pdg;
  flat::Flat<int> reco_nc;
  flat::Flat<int> reco_nue;
  flat::Flat<int> reco_numu;
  flat::Flat<int> reco_q;
  flat::Flat<int> run;
  flat::Flat<float> sigma_Elep_reco;
  flat::Flat<float> sigma_Ev_reco;
  flat::Flat<float> sigma_nue_pid;
  flat::Flat<float> sigma_numu_pid;
  flat::Flat<int> subrun;
  flat::Flat<float> theta_reco;
  flat::Flat<float> total_xsSyst_cv_wgt;
  flat::Flat<float> vtx_x;
  flat::Flat<float> vtx_y;
  flat::Flat<float> vtx_z;
  flat::Flat<std::vector<float>> wgt_CrazyFlux;
  flat::Flat<std::vector<std::vector<float>>> xsSyst_wgt;
};
